/**
 * @legal
 * This code is largely based on code from the Vue 3 codebase:
 * https://github.com/vuejs/core/blob/f67bb500b6071bc0e55a89709a495a27da73badd/packages/runtime-core/src/componentOptions.ts#L823-L876
 * https://github.com/vuejs/core/blob/f67bb500b6071bc0e55a89709a495a27da73badd/packages/runtime-core/src/componentOptions.ts#L1073-L1084
 */
import { type ComponentPublicInstance, type DebuggerEvent } from 'vue';
export declare type ComponentInjectOptions = string[] | ObjectInjectOptions;
export declare type ObjectInjectOptions = Record<string | symbol, string | symbol | {
    from?: string | symbol;
    default?: unknown;
}>;
export declare type DebuggerHook = (e: DebuggerEvent) => void;
export declare type ErrorCapturedHook<TError = unknown> = (err: TError, instance: ComponentPublicInstance | null, info: string) => boolean | void;
export declare function resolveInjections(injectOptions: ComponentInjectOptions, ctx: any): void;
