import { type ComponentInternalInstance, type ComponentPublicInstance } from 'vue';
export declare const isFunction: (val: unknown) => val is Function;
export declare const isArray: (arg: any) => arg is any[];
export declare const isObject: (val: unknown) => val is Record<any, any>;
export declare const isString: (val: unknown) => val is string;
/**
 * @legal
 * taken from the Vue 3 Codebase, slightly adjusted:
 * https://github.com/vuejs/core/blob/f67bb500b6071bc0e55a89709a495a27da73badd/packages/runtime-core/src/componentOptions.ts#L878-L890
 */
export declare function callHook(hook: Function, instance: ComponentInternalInstance, vm: ComponentPublicInstance, type: 'c' | 'bc'): void;
